Package: tidyfit
Type: Package
Title: Regularized Linear Modeling with Tidy Data
Date: 2024-09-30
Version: 0.7.2
Author: Johann Pfitzinger [aut, cre]
Authors@R: person(given = "Johann", family = "Pfitzinger", role = c("aut", "cre"), email = "johann.pfitzinger@gmail.com")
Maintainer: Johann Pfitzinger <johann.pfitzinger@gmail.com>
Description: An extension to the 'R' tidy data environment for automated machine learning. The package allows fitting and cross validation of linear regression and classification algorithms on grouped data. 
License: GPL-3
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.2
URL: https://tidyfit.residualmetrics.com,
        https://github.com/jpfitzinger/tidyfit
Depends: R (>= 3.5)
Imports: broom, crayon, dials, dplyr, furrr, generics, magrittr, MASS,
        methods, progressr, purrr, rlang, rsample, stats, tibble,
        tidyr, utils, vctrs, yardstick
Suggests: arm, bestglm, BMS, BoomSpikeSlab, CORElearn, e1071, gaselect,
        gets, gglasso, ggplot2, glmnet, hfr, iml, kableExtra, knitr,
        lme4, lmtest, lubridate, markdown, mboost, monomvn, mRMRe,
        MSwM, nnet, pls, quantreg, quantregForest, randomForest,
        sandwich, sensitivity, shrinkTVP, stringr, rmarkdown, testthat
        (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2024-10-03 13:20:19 UTC; johann
Repository: CRAN
Date/Publication: 2024-10-03 13:40:02 UTC
Built: R 4.4.1; ; 2024-11-06 04:09:37 UTC; unix

## ----include = FALSE, eval=TRUE-----------------------------------------------
use_saved_results <- TRUE

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  eval = !use_saved_results,
  message = FALSE,
  warning = FALSE
)

if (use_saved_results) {
  library(pls)
  results <- readRDS("vignette_bci.rds")
  estimates <- results$estimates
  jackknife_estimates <- results$jackknife_estimates
}

## ----eval=TRUE----------------------------------------------------------------
library(dplyr); library(tidyr); library(purrr); library(ggplot2) # Data wrangling
library(tidyfit) # Model fitting

## ----eval=TRUE----------------------------------------------------------------
data <- MASS::Boston %>% 
  scale %>% 
  as_tibble

## -----------------------------------------------------------------------------
#  model_frame <- data %>%
#    regress(medv ~ ., m("plsr", ncomp = 5), m("pcr", ncomp = 5),
#            .cv = "bootstraps", .cv_args = list(times = 100),
#            .return_slices = TRUE)

## -----------------------------------------------------------------------------
#  estimates <- coef(model_frame,
#                    .add_bootstrap_interval = TRUE,
#                    .bootstrap_alpha = 0.05)

## ----eval=TRUE----------------------------------------------------------------
estimates

## ----eval=TRUE----------------------------------------------------------------
estimates <- estimates %>% 
  unnest(model_info)
estimates

## ----fig.width=7, fig.height=3.5, fig.align="center", eval=TRUE---------------
estimates %>% 
  filter(term != "(Intercept)") %>% 
  ggplot(aes(term, estimate, color = model)) +
  geom_hline(yintercept = 0) +
  geom_errorbar(aes(ymin = .lower, ymax = .upper), position = position_dodge()) +
  theme_bw(8)

## -----------------------------------------------------------------------------
#  model_frame_jackknife <- data %>%
#    regress(medv ~ ., m("plsr", ncomp = 5, jackknife = TRUE, validation = "LOO"),
#            m("pcr", ncomp = 5, jackknife = TRUE, validation = "LOO"))
#  
#  jackknife_estimates <- coef(model_frame_jackknife)

## ----eval = TRUE--------------------------------------------------------------
jackknife_estimates <- jackknife_estimates %>% 
  unnest(model_info) %>% 
  # Create approximate 95% intervals using 2 standard deviations
  mutate(.upper = estimate + 2 * std.error, .lower = estimate - 2 * std.error)

jackknife_estimates

## ----fig.width=7, fig.height=3.5, fig.align="center", eval=TRUE---------------
jackknife_estimates %>% 
  filter(term != "(Intercept)") %>% 
  ggplot(aes(term, estimate, color = model)) +
  geom_hline(yintercept = 0) +
  geom_errorbar(aes(ymin = .lower, ymax = .upper), position = position_dodge()) +
  theme_bw(8)

## ----include = FALSE----------------------------------------------------------
use_saved_results <- TRUE

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  eval = !use_saved_results,
  message = FALSE,
  warning = FALSE
)

if (use_saved_results) {
  results <- readRDS("vignette_mc.rds")
  pred <- results$pred
}

## ----eval=TRUE----------------------------------------------------------------
library(dplyr); library(tidyr); library(purrr) # Data wrangling
library(ggplot2); library(stringr) # Plotting
library(tidyfit)   # Auto-ML modeling

## ----eval=TRUE----------------------------------------------------------------
data("iris")

# For reproducibility
set.seed(42)
ix_tst <- sample(1:nrow(iris), round(nrow(iris)*0.2))

data_trn <- iris[-ix_tst,]
data_tst <- iris[ix_tst,]

as_tibble(iris)

## -----------------------------------------------------------------------------
#  fit <- data_trn %>%
#    classify(Species ~ .,
#             LASSO = m("lasso"),
#             Ridge = m("ridge"),
#             ElasticNet = m("enet"),
#             AdaLASSO = m("adalasso"),
#             SVM = m("svm"),
#             `Random Forest` = m("rf"),
#             `Least Squares` = m("ridge", lambda = 1e-5),
#             .cv = "vfold_cv")
#  
#  pred <- fit %>%
#    predict(data_tst)

## ----fig.width=7, fig.height=3, fig.align="center", eval=TRUE-----------------
metrics <- pred %>% 
  group_by(model, class) %>% 
  mutate(row_n = row_number()) %>% 
  spread(class, prediction) %>% 
  group_by(model) %>% 
  yardstick::mn_log_loss(truth, setosa:virginica)

metrics %>% 
  mutate(model = str_wrap(model, 11)) %>% 
  ggplot(aes(model, .estimate)) +
  geom_col(fill = "darkblue") +
  theme_bw() +
  theme(axis.title.x = element_blank())

## ----include = FALSE----------------------------------------------------------
use_saved_results <- TRUE

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  eval = !use_saved_results,
  message = FALSE,
  warning = FALSE
)

if (use_saved_results) {
  results <- readRDS("vignette_rwtsr.rds")
  df_beta <- results$df_beta
}

## ----eval=TRUE----------------------------------------------------------------
library(dplyr); library(tidyr); library(purrr) # Data wrangling
library(ggplot2); library(stringr) # Plotting
library(lubridate)   # Date calculations
library(tidyfit)     # Model fitting

## ----eval=TRUE----------------------------------------------------------------
data <- Factor_Industry_Returns
data <- data %>% 
  mutate(Date = ym(Date)) %>%         # Parse dates
  mutate(Return = Return - RF) %>%    # Excess return
  select(-RF)
data

## ----eval=TRUE----------------------------------------------------------------
data <- data %>% 
  group_by(Industry)

## ----eval=TRUE----------------------------------------------------------------
mod_frame <- data %>% 
  regress(Return ~ CMA + HML + `Mkt-RF` + RMW + SMB, m("lm"))

mod_frame

## ----eval=TRUE----------------------------------------------------------------
mod_frame_hac <- data %>% 
  regress(Return ~ CMA + HML + `Mkt-RF` + RMW + SMB, m("lm", vcov. = "HAC"))

mod_frame_hac

## -----------------------------------------------------------------------------
#  mod_frame_rolling <- data %>%
#    regress(Return ~ CMA + HML + `Mkt-RF` + RMW + SMB,
#            m("lm", vcov. = "HAC"),
#            .cv = "sliding_index", .cv_args = list(lookback = years(5), step = 6, index = "Date"),
#            .force_cv = TRUE, .return_slices = TRUE)

## -----------------------------------------------------------------------------
#  df_beta <- coef(mod_frame_rolling)

## ----eval=TRUE----------------------------------------------------------------
df_beta

## ----eval=TRUE----------------------------------------------------------------
df_beta <- df_beta %>% 
  unnest(model_info) %>% 
  mutate(upper = estimate + 2 * std.error, lower = estimate - 2 * std.error)

## ----eval=TRUE----------------------------------------------------------------
df_beta

## ----fig.width=7, fig.height=5, fig.align="center", eval=TRUE-----------------
df_beta %>% 
  mutate(slice_id = as.Date(slice_id)) %>% 
  filter(term == "Mkt-RF") %>% 
  ggplot(aes(slice_id)) +
  geom_hline(yintercept = 1) +
  facet_wrap("Industry", scales = "free") +
  geom_ribbon(aes(ymax = upper, ymin = lower), alpha = 0.25) +
  geom_line(aes(y = estimate)) +
  theme_bw(8)

## ----fig.width=7, fig.height=5, fig.align="center", eval=TRUE-----------------
df_beta %>% 
  mutate(slice_id = as.Date(slice_id)) %>% 
  filter(term == "(Intercept)") %>% 
  ggplot(aes(slice_id)) +
  geom_hline(yintercept = 0) +
  facet_wrap("Industry", scales = "free") +
  geom_ribbon(aes(ymax = upper, ymin = lower), alpha = 0.25) +
  geom_line(aes(y = estimate)) +
  theme_bw(8)

## ----fig.width=6, fig.height=4.25, fig.align="center", eval=TRUE--------------
df_beta %>% 
  mutate(slice_id = as.Date(slice_id)) %>% 
  filter(Industry == "HiTec") %>% 
  ggplot(aes(slice_id)) +
  geom_hline(yintercept = 0) +
  facet_wrap("term", scales = "free") +
  geom_ribbon(aes(ymax = upper, ymin = lower), alpha = 0.25) +
  geom_line(aes(y = estimate)) +
  theme_bw(8)

## ----setup, include=FALSE-----------------------------------------------------
use_saved_results <- TRUE

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  eval = !use_saved_results,
  message = FALSE,
  warning = FALSE
)

if (use_saved_results) {
  results <- readRDS("vignette_fs.rds")
  model_df <- results$model_df
  boot_df <- results$boot_df
}

## ----eval=TRUE, class.source = "fold-hide"------------------------------------
library(dplyr); library(tidyr); library(purrr) # Data wrangling
library(ggplot2); library(stringr) # Plotting
library(tidyfit) # Model fitting

# Max model size
MODEL_SIZE <- 10

## ----eval=TRUE----------------------------------------------------------------
# Load the data
data <- readRDS("FRED-MD.rds")

## ----eval=TRUE----------------------------------------------------------------
data <- data %>% 
  arrange(date) %>% 
  # Shift the target by 1 month
  mutate(Target = lead(INDPRO)) %>% 
  drop_na %>% 
  select(-date)

data

## -----------------------------------------------------------------------------
#  # Correlation
#  algorithms_df <- data %>%
#    regress(Target ~ ., Correlation = m("cor"))

## -----------------------------------------------------------------------------
#  # RReliefF
#  algorithms_df <- algorithms_df %>%
#    bind_rows(
#      data %>%
#        regress(Target ~ ., RReliefF = m("relief"))
#    )

## -----------------------------------------------------------------------------
#  # Information Gain
#  algorithms_df <- algorithms_df %>%
#    bind_rows(
#      data %>%
#        # Split target into buckets
#        mutate(Target = as.factor(ntile(Target, 10))) %>%
#        regress(Target ~ .,
#                `Information Gain` = m("relief", estimator = "InfGain"))
#    )

## -----------------------------------------------------------------------------
#  # Forward Selection
#  algorithms_df <- algorithms_df %>%
#    bind_rows(
#      data %>%
#        regress(Target ~ .,
#                `Forward Selection` = m("subset", method = "forward", nvmax = MODEL_SIZE))
#    )

## -----------------------------------------------------------------------------
#  # Backward Elimination
#  algorithms_df <- algorithms_df %>%
#    bind_rows(
#      data %>%
#        regress(Target ~ .,
#                `Backward Elimination` = m("subset", method = "backward", nvmax = MODEL_SIZE))
#    )

## -----------------------------------------------------------------------------
#  # MRMR
#  algorithms_df <- algorithms_df %>%
#    bind_rows(
#      data %>%
#        regress(Target ~ ., MRMR = m("mrmr", feature_count = MODEL_SIZE))
#    )

## -----------------------------------------------------------------------------
#  # LASSO
#  algorithms_df <- algorithms_df %>%
#    bind_rows(
#      data %>%
#        regress(Target ~ .,
#                `LASSO` = m("lasso", pmax = MODEL_SIZE + 1),
#                .cv = "rolling_origin",
#                .cv_args = list(initial = 120, assess = 24, skip = 23)
#                )
#    )

## -----------------------------------------------------------------------------
#  # BMA
#  algorithms_df <- algorithms_df %>%
#    bind_rows(
#      data %>%
#        regress(Target ~ .,
#                BMA = m("bma", burn = 10000, iter = 100000,
#                        mprior.size = MODEL_SIZE, mcmc = "rev.jump"))
#    )

## -----------------------------------------------------------------------------
#  # Random Forest Importance
#  nonlinear_algorithms_df <- data %>%
#        regress(Target ~ ., `RF Importance` = m("rf"))

## -----------------------------------------------------------------------------
#  coef_df <- coef(algorithms_df) %>%
#    unnest(model_info) %>%
#    bind_rows(explain(nonlinear_algorithms_df))

## -----------------------------------------------------------------------------
#  model_df <- coef_df %>%
#    # Always remove the intercept
#    filter(term != "(Intercept)") %>%
#  
#    mutate(selected = case_when(
#      # Extract top 10 largest scores
#      model %in% c("Correlation", "RReliefF", "Information Gain") ~
#        rank(-abs(estimate)) <= MODEL_SIZE,
#      # BMA features are selected using the posterior inclusion probability
#      model == "BMA" ~ rank(-pip) <= MODEL_SIZE,
#      # The RF importance is stored in a separate column (%IncMSE)
#      model == "RF Importance" ~ rank(-importance) <= MODEL_SIZE,
#      # For all other methods keep all features
#      TRUE ~ TRUE
#    )) %>%
#  
#    # Keep only included terms
#    filter(selected) %>%
#    select(model, term)

## -----------------------------------------------------------------------------
#  model_df <- model_df %>%
#    bind_rows(tibble(
#      model = "Domain Expert",
#      term = c("NAPMNOI", "ANDENOx", "CLAIMSx", "ACOGNO",
#               "S&P 500", "T10YFFM", "PERMIT", "AWHMAN")
#    ))

## ----eval=T, class.source = 'fold-hide', fig.width=7, fig.height=2.5, fig.align='center'----
model_df %>% 
  # Add 'FALSE' entries, when a feature is not selected
  mutate(selected = TRUE) %>% 
  spread(term, selected) %>% 
  gather("term", "selected", -model) %>% 
  # Plotting color
  mutate(selected = ifelse(is.na(selected), "white", "darkblue")) %>% 
  # Fix plotting order
  group_by(term) %>% 
  mutate(selected_sum = sum(selected=="darkblue")) %>% 
  ungroup %>% 
  arrange(desc(selected_sum)) %>% 
  mutate(term = factor(term, levels = unique(term))) %>% 
  mutate(model = factor(model, levels = unique(model_df$model))) %>% 
  ggplot(aes(term, model)) +
  geom_tile(aes(fill = selected)) +
  theme_bw(8, "Arial") +
  scale_fill_identity() +
  xlab(element_blank()) + ylab(element_blank()) +
  theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust=1))

## -----------------------------------------------------------------------------
#  model_names <- unique(model_df$model)
#  
#  # Retrieve selected variables
#  selected_vars_list <- model_names %>%
#    map(function(mod) {
#      model_df %>%
#        filter(model == mod) %>%
#        pull(term)
#    })
#  names(selected_vars_list) <- model_names
#  
#  # Bootstrap resampling & regression
#  boot_models_df <- selected_vars_list %>%
#    map_dfr(function(selected_vars) {
#      data %>%
#        select(all_of(c("Target", selected_vars))) %>%
#  
#        regress(Target ~ .,
#                # Use linear regression
#                m("lm"),
#                # Bootstrap settings (see ?rsample::bootstraps)
#                .cv = "bootstraps", .cv_args = list(times = 100),
#                # Make sure the results for each slice are returned
#                .force_cv = T, .return_slices = T)
#    }, .id = "model")
#  
#  # Finally, extract R2 from the model results
#  boot_df <- boot_models_df %>%
#    mutate(R2 = map_dbl(model_object, function(obj) summary(obj)$r.squared)) %>%
#    select(model, R2)

## ----eval=T, class.source = 'fold-hide', fig.width=7, fig.height=2.5, fig.align='center'----
boot_df %>% 
  group_by(model) %>% 
  mutate(upper = mean(R2) + 2 * sd(R2) / sqrt(n()),
         lower = mean(R2) - 2 * sd(R2) / sqrt(n())) %>% 
  mutate(model = str_wrap(model, 10)) %>% 
  mutate(model = factor(model, levels = str_wrap(unique(model_df$model), 10))) %>% 
  ggplot(aes(model)) +
  geom_errorbar(aes(ymin = lower, ymax = upper), linewidth = 0.25, width = 0.25) +
  theme_bw(8, "Arial") +
  xlab(element_blank()) + ylab("R2 statistic")

test_that("hfr regression works", {
  library(dplyr)
  df_reg <- MASS::Boston
  colnames(df_reg)[1] <- "some non-syntactic name"
  df_cls3 <- iris
  df_cls2 <- iris %>% filter(Species != "setosa")

  m_reg <- m("hfr", medv ~ ., df_reg, kappa = 0.4)
  expect_equal(nrow(coef(m_reg)), 14)
  expect_equal(nrow(predict(m_reg, df_reg)), 506)
  expect_equal(nrow(fitted(m_reg)), 506)
  expect_equal(nrow(resid(m_reg)), 506)
  expect_equal(nrow(predict(m_reg, df_reg %>% select(-medv))), 506)

})

test_that("ridge regression works", {
  library(dplyr)
  df_reg <- MASS::Boston
  colnames(df_reg)[1] <- "some non-syntactic name"
  df_cls3 <- iris
  df_cls2 <- iris %>% filter(Species != "setosa")

  m_reg <- m("ridge", medv ~ ., df_reg, lambda = c(0.1))
  expect_equal(nrow(coef(m_reg)), 14)
  expect_equal(nrow(predict(m_reg, df_reg)), 506)
  expect_equal(nrow(fitted(m_reg)), 506)
  expect_equal(nrow(resid(m_reg)), 506)
  expect_equal(nrow(predict(m_reg, df_reg %>% select(-medv))), 506)

})

test_that("ridge classification works", {
  library(dplyr)
  df_cls3 <- iris
  df_cls2 <- iris %>% filter(Species != "setosa")

  m_reg <- classify(df_cls3, Species ~ ., m("ridge", lambda = c(0.1)))
  expect_equal(nrow(coef(m_reg)), 15)
  expect_equal(nrow(predict(m_reg, df_cls3)), 450)
  expect_equal(nrow(fitted(m_reg)), 450)
  expect_equal(nrow(predict(m_reg, df_cls3 %>% select(-Species))), 450)

})

test_that("ridge classification (2class) works", {
  library(dplyr)
  df_cls3 <- iris
  df_cls2 <- iris %>% filter(Species != "virginica")

  m_reg <- classify(df_cls2, Species ~ ., m("ridge", lambda = c(0.01)))
  expect_equal(nrow(coef(m_reg)), 5)
  expect_equal(nrow(predict(m_reg, df_cls2)), 100)
  expect_equal(nrow(fitted(m_reg)), 100)
  expect_equal(nrow(predict(m_reg, df_cls2 %>% select(-Species))), 100)

})

test_that("glmm regression works", {
  library(dplyr)
  df_reg <- tidyfit::Factor_Industry_Returns

  m_reg <- m("glmm", Return ~ `Mkt-RF` + `Mkt-RF` | Industry, df_reg)
  expect_equal(nrow(coef(m_reg)), 11)
  expect_equal(nrow(predict(m_reg, df_reg[1:10,])), 10)
  expect_equal(nrow(fitted(m_reg)), 7080)
  expect_equal(nrow(resid(m_reg)), 7080)
  expect_equal(nrow(predict(m_reg, df_reg %>% select(-Return))), 7080)

})

test_that("glm classification works", {
  library(dplyr)
  df_reg <- tidyfit::Factor_Industry_Returns
  df_reg$Return <- ifelse(df_reg$Return > 0, 1, 0)

  m_reg <- classify(df_reg, Return ~ CMA + CMA | Industry, m("glmm"))
  expect_equal(nrow(coef(m_reg)), 11)
  expect_equal(nrow(predict(m_reg, df_reg[1:10,])), 10)
  expect_equal(nrow(fitted(m_reg)), 7080)
  expect_equal(nrow(predict(m_reg, df_reg %>% select(-Return))), 7080)

})

test_that("quantile rf regression works", {
  library(dplyr)
  df_reg <- MASS::Boston
  colnames(df_reg)[1] <- "some non-syntactic name"

  m_reg <- m("quantile_rf", medv ~ ., df_reg, tau = 0.4)
  expect_equal(nrow(tidyfit::explain(m_reg, use_package = "randomForest")), 14)
  expect_equal(nrow(predict(m_reg, df_reg)), 506)
  expect_equal(nrow(fitted(m_reg)), 506)
  expect_equal(nrow(resid(m_reg)), 506)
  expect_equal(nrow(predict(m_reg, df_reg %>% select(-medv))), 506)

})

test_that("cor regression works", {
  library(dplyr)
  df_reg <- MASS::Boston
  colnames(df_reg)[1] <- "some non-syntactic name"
  df_cls3 <- iris
  df_cls2 <- iris %>% filter(Species != "setosa")

  m_reg <- m("cor", medv ~ ., df_reg)
  expect_equal(nrow(coef(m_reg)), 13)

})

test_that("chisq classification works", {
  library(dplyr)
  df_cls3 <- iris
  df_cls2 <- iris %>% filter(Species != "virginica")

  m_reg1 <- classify(df_cls2, Species ~ ., m("chisq"))
  m_reg2 <- classify(df_cls3, Species ~ ., m("chisq"))
  expect_equal(nrow(coef(m_reg1)), 4)
  expect_equal(nrow(coef(m_reg2)), 4)

})

test_that("boost regression works", {
  library(dplyr)
  df_reg <- MASS::Boston
  colnames(df_reg)[1] <- "some non-syntactic name"
  df_cls3 <- iris
  df_cls2 <- iris %>% filter(Species != "setosa")

  m_reg <- m("boost", medv ~ ., df_reg, mstop = 100, nu = 0.1)
  expect_equal(nrow(coef(m_reg)), 14)
  expect_equal(nrow(predict(m_reg, df_reg)), 506)
  expect_equal(nrow(fitted(m_reg)), 506)
  expect_equal(nrow(resid(m_reg)), 506)
  expect_equal(nrow(predict(m_reg, df_reg %>% select(-medv))), 506)

})

test_that("bayes classification works", {
  library(dplyr)
  df_cls3 <- iris
  df_cls2 <- iris %>% filter(Species != "virginica")
  df_cls2$Species <- factor(df_cls2$Species, levels = sort(unique(df_cls2$Species)))

  m_reg <- classify(df_cls2, Species ~ ., m("boost", mstop = 100, nu = 0.1))
  expect_equal(nrow(coef(m_reg)), 5)
  expect_equal(nrow(predict(m_reg, df_cls2)), 100)
  expect_equal(nrow(fitted(m_reg)), 100)
  expect_equal(nrow(predict(m_reg, df_cls2 %>% select(-Species))), 100)

})

---
title: "Flowchart"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Flowchart}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  message = FALSE,
  warning = FALSE
)
```

The following flowchart illustrates how `tidyfit` processes data and fits models:

![](ProcessChart.jpg)

---
title: "Multinomial Classification"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Multinomial Classification}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
use_saved_results <- TRUE

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  eval = !use_saved_results,
  message = FALSE,
  warning = FALSE
)

if (use_saved_results) {
  results <- readRDS("vignette_mc.rds")
  pred <- results$pred
}
```

```{r, eval=TRUE}
library(dplyr); library(tidyr); library(purrr) # Data wrangling
library(ggplot2); library(stringr) # Plotting
library(tidyfit)   # Auto-ML modeling
```

Multinomial classification is possible in `tidyfit` using the methods powered by `glmnet`, `e1071` and `randomForest` (LASSO, Ridge, ElasticNet,  AdaLASSO, SVM and Random Forest). Currently, none of the other methods support multinomial classification.^[Feature selection methods such as `relief` or `chisq` can be used with multinomial response variables. I may also add support for multinomial classification with `mboost` in future.] When the response variable contains more than 2 classes, `classify` automatically uses a multinomial response for the above-mentioned methods.

Here's an example using the built-in `iris` dataset:

```{r, eval=TRUE}
data("iris")

# For reproducibility
set.seed(42)
ix_tst <- sample(1:nrow(iris), round(nrow(iris)*0.2))

data_trn <- iris[-ix_tst,]
data_tst <- iris[ix_tst,]

as_tibble(iris)
```

## Penalized classification algorithms to predict `Species`

The code chunk below fits the above mentioned algorithms on the training split, using a 10-fold cross validation to select optimal penalties. We then obtain out-of-sample predictions using `predict`. Unlike binomial classification, the `fit` and `pred` objects contain a `class` column with separate coefficients and predictions for each class. The predictions sum to one across classes:

```{r}
fit <- data_trn %>% 
  classify(Species ~ ., 
           LASSO = m("lasso"), 
           Ridge = m("ridge"), 
           ElasticNet = m("enet"), 
           AdaLASSO = m("adalasso"),
           SVM = m("svm"),
           `Random Forest` = m("rf"),
           `Least Squares` = m("ridge", lambda = 1e-5), 
           .cv = "vfold_cv")

pred <- fit %>% 
  predict(data_tst)
```

Note that we can add unregularized least squares estimates by setting `lambda = 0` (or very close to zero).

Next, we can use `yardstick` to calculate the log loss accuracy metric and compare the performance of the different models:

```{r, fig.width=7, fig.height=3, fig.align="center", eval=TRUE}
metrics <- pred %>% 
  group_by(model, class) %>% 
  mutate(row_n = row_number()) %>% 
  spread(class, prediction) %>% 
  group_by(model) %>% 
  yardstick::mn_log_loss(truth, setosa:virginica)

metrics %>% 
  mutate(model = str_wrap(model, 11)) %>% 
  ggplot(aes(model, .estimate)) +
  geom_col(fill = "darkblue") +
  theme_bw() +
  theme(axis.title.x = element_blank())
```

The least squares estimate performs poorest, while the random forest (nonlinear) and the support vector machine (SVM) achieve the best results. The SVM is estimated with a linear kernel by default (use `kernel = <chosen_kernel>` to use a different kernel).

---
title: "Rolling Window Time Series Regression"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Rolling Window Time Series Regression}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
use_saved_results <- TRUE

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  eval = !use_saved_results,
  message = FALSE,
  warning = FALSE
)

if (use_saved_results) {
  results <- readRDS("vignette_rwtsr.rds")
  df_beta <- results$df_beta
}
```

In this short tutorial, I show how to calculate a rolling regression on grouped time series data using `tidyfit`. With very few lines of code, we will be able to estimate and analyze a large number of regressions. As usual, begin by loading necessary libraries:

```{r, eval=TRUE}
library(dplyr); library(tidyr); library(purrr) # Data wrangling
library(ggplot2); library(stringr) # Plotting
library(lubridate)   # Date calculations
library(tidyfit)     # Model fitting
```

The data set consists monthly industry returns for 10 industries, as well as monthly factor returns for 5 Fama-French factors (data set is available  [here](https://mba.tuck.dartmouth.edu/pages/faculty/ken.french/data_library.html)). The factors are:

  1. The market risk premium `Mkt-RF`
  2. Size `SMB` (small minus big)
  3. Value `HML` (high minus low)
  4. Profitability `RMW` (robust minus weak)
  5. Investment `CMA` (conservative minus aggressive)
  
Returns are provided for 10 industries, and excess returns are calculated by subtracting the risk free rate from the monthly industry returns:

```{r, eval=TRUE}
data <- Factor_Industry_Returns
data <- data %>% 
  mutate(Date = ym(Date)) %>%         # Parse dates
  mutate(Return = Return - RF) %>%    # Excess return
  select(-RF)
data
```

The aim of the analysis is to calculate rolling window factor betas using a regression for each industry. To fit a regression for each industry, we simply group the data:

```{r, eval=TRUE}
data <- data %>% 
  group_by(Industry)
```

Let's verify that this fits individual regressions:

```{r, eval=TRUE}
mod_frame <- data %>% 
  regress(Return ~ CMA + HML + `Mkt-RF` + RMW + SMB, m("lm"))

mod_frame
```

The model frame now contains 10 regressions estimated using `stats::lm`. We may want to fit the regression using a heteroscedasticity and autocorrelation consistent (HAC) estimate of the covariance matrix, since we are working with financial time series. This can be done by passing the additional argument to `m(...)`:^[Note that the `...` in `m()` passes arguments to the underlying method (i.e. `stats::lm`). However in some cases `tidyfit` adds convenience functions, such as the ability to pass a `vcov.` argument as used in `coeftest` for `lm`.]

```{r, eval=TRUE}
mod_frame_hac <- data %>% 
  regress(Return ~ CMA + HML + `Mkt-RF` + RMW + SMB, m("lm", vcov. = "HAC"))

mod_frame_hac
```

A rolling window regression can be estimated by specifying an appropriate cross validation method. `tidyfit` uses the `rsample` package from the `tidymodels` suite to create cross validation slices. Apart from the classic CV methods (vfold, loo, expanding window, train/test split), this also includes sliding functions (`sliding_window`, `sliding_index` and `sliding_period`), as well as `bootstraps`. The sliding functions do not generate a validation slice, but only create rolling window training slices. We will be using `sliding_index`, which works well with date indices. See `?rsample::sliding_index` for specifics.^[It is important to note that `sliding_index` can not be used to select hyperparameters since no test slices are produced. To perform time series CV, use the `rolling_origin` setting, which is similar, but produces train and test splits.]

Since the method `lm` has no hyperparameters, it is not passed to the cross validation loop by default, since this would create unnecessary computational overhead. To ensure that models are fitted on train slices, we need to add the additional argument `.force_cv = TRUE`. Furthermore, the CV slices are typically not returned but only used to select optimal hyperparameters. To return slices set `.return_slices = TRUE`:

```{r}
mod_frame_rolling <- data %>% 
  regress(Return ~ CMA + HML + `Mkt-RF` + RMW + SMB,
          m("lm", vcov. = "HAC"),
          .cv = "sliding_index", .cv_args = list(lookback = years(5), step = 6, index = "Date"),
          .force_cv = TRUE, .return_slices = TRUE)
```

The `.cv_args` are arguments passed directly to `rsample::sliding_index`. We are using a 5 year window (`lookback = years(5)`), and skipping 6 months between each window to reduce the number of models fitted (`step = 6`).

The model frame now contains models for each slice for each industry. The `slice_id` provides the valid date for the respective slices. Betas can be extracted using the built-in `coef` function:

```{r}
df_beta <- coef(mod_frame_rolling)
```

```{r, eval=TRUE}
df_beta
```

In order to plot the betas, we will add confidence bands. HAC standard errors are nested in `model_info` in the coefficients frame:

```{r, eval=TRUE}
df_beta <- df_beta %>% 
  unnest(model_info) %>% 
  mutate(upper = estimate + 2 * std.error, lower = estimate - 2 * std.error)
```

```{r, eval=TRUE}
df_beta
```

Now, with all the pieces in place, we can plot the results. Let's begin by examining the market beta for each industry using `ggplot2`:

```{r, fig.width=7, fig.height=5, fig.align="center", eval=TRUE}
df_beta %>% 
  mutate(slice_id = as.Date(slice_id)) %>% 
  filter(term == "Mkt-RF") %>% 
  ggplot(aes(slice_id)) +
  geom_hline(yintercept = 1) +
  facet_wrap("Industry", scales = "free") +
  geom_ribbon(aes(ymax = upper, ymin = lower), alpha = 0.25) +
  geom_line(aes(y = estimate)) +
  theme_bw(8)
```

Or plotting risk-adjusted return (alpha) given by the intercept:

```{r, fig.width=7, fig.height=5, fig.align="center", eval=TRUE}
df_beta %>% 
  mutate(slice_id = as.Date(slice_id)) %>% 
  filter(term == "(Intercept)") %>% 
  ggplot(aes(slice_id)) +
  geom_hline(yintercept = 0) +
  facet_wrap("Industry", scales = "free") +
  geom_ribbon(aes(ymax = upper, ymin = lower), alpha = 0.25) +
  geom_line(aes(y = estimate)) +
  theme_bw(8)
```

Or plotting all parameters for the HiTec industry:

```{r, fig.width=6, fig.height=4.25, fig.align="center", eval=TRUE}
df_beta %>% 
  mutate(slice_id = as.Date(slice_id)) %>% 
  filter(Industry == "HiTec") %>% 
  ggplot(aes(slice_id)) +
  geom_hline(yintercept = 0) +
  facet_wrap("term", scales = "free") +
  geom_ribbon(aes(ymax = upper, ymin = lower), alpha = 0.25) +
  geom_line(aes(y = estimate)) +
  theme_bw(8)
```

While there are certainly very interesting insights to be had here, the aim of this walk-through is not to interpret these results, but rather to demonstrate how a complex piece of analysis can be done very efficiently using the `tidyfit` package.

In a follow-up article found [here](https://tidyfit.unchartedml.com/articles/Time-varying_parameters_vs_rolling_windows.html), I compare the results in the plot above to a time-varying parameter regression to show how more robust methods can be used to avoid window effects in the rolling sample and to shrink some coefficients to constant values.

---
title: "Time-varying parameters vs. rolling windows"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Time-varying parameters vs. rolling windows}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
use_saved_results <- TRUE

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  eval = !use_saved_results,
  message = FALSE,
  warning = FALSE
)

if (use_saved_results) {
  results <- readRDS("vignette_tvpvsrw.rds")
  beta <- results$beta
}
```

In this tutorial, I compare the coefficients estimated using a rolling window regression to those estimated using a Bayesian time-varying parameter model. For a primer on how to fit rolling window regressions using `tidyfit`, please see [here](https://tidyfit.unchartedml.com/articles/Rolling_Window_Time_Series_Regression.html). This articles follows directly from the linked primer, but focuses on only one industry.

```{r, eval=TRUE}
library(dplyr); library(tidyr); library(purrr) # Data wrangling
library(ggplot2); library(stringr) # Plotting
library(lubridate)   # Date calculations
library(tidyfit)     # Model fitting
```

## Load the data

```{r, eval=TRUE}
data <- Factor_Industry_Returns
data <- data %>% 
  mutate(Date = ym(Date)) %>%         # Parse dates
  mutate(Return = Return - RF) %>%    # Excess return
  select(-RF)
data
```

We will examine only the HiTec industry to avoid unnecessary complexity:

```{r, eval=TRUE}
data <- data %>% 
  filter(Industry == "HiTec") %>% 
  select(-Industry)
```

## Model fitting

We begin by fitting a rolling window OLS regression with adjusted standard errors. In this example, we cannot simply pass both the TVP and the OLS models to the same `regress` function because the rolling window regression requires a `.force_cv = TRUE` argument, while the TVP model does not need to be fitted on rolling slices. The below code is adapted directly from the previous article on rolling window regressions:

```{r}
mod_rolling <- data %>% 
  regress(Return ~ CMA + HML + `Mkt-RF` + RMW + SMB,
          m("lm", vcov. = "HAC"),
          .cv = "sliding_index", .cv_args = list(lookback = years(5), step = 6, index = "Date"),
          .force_cv = TRUE, .return_slices = TRUE)
```

The TVP model is fitted next. `tidyfit` uses the `shrinkTVP` package to fit TVP models. The package is extremely powerful and provides a Bayesian implementation with a specialized hierarchical prior that automatically shrinks some of the parameters towards constant processes based on the data. While I do not discuss this in more detail, have a look here for more information.

```{r}
mod_tvp <- data %>% 
  regress(Return ~ .,
          m("tvp", sv = TRUE, niter = 1000, index_col = "Date"))
```

The `sv = TRUE` adds stochastic volatility, while the `index_col` argument is a convenience feature added by `tidyfit` to allow the index column (i.e. the dates) to be passed through to the estimates.

Next we combine the two model frames:

```{r}
mod_frame <- bind_rows(mod_rolling, mod_tvp)
```

The coefficients for all models can be obtained in the usual manner:

```{r}
beta <- coef(mod_frame)
```

Now, however, we require some wrangling to adapt the output of the two methods. First we unnest the detailed model information. This contains upper and lower credible intervals for the TVP model. For the OLS model we generate the confidence interval, as before. Finally, we combine the `slice_id` and `index` columns into a joint `date` column:

```{r}
beta <- beta %>% 
  unnest(model_info) %>% 
  mutate(lower = ifelse(is.na(lower), estimate - 2*std.error, lower)) %>% 
  mutate(upper = ifelse(is.na(upper), estimate + 2*std.error, upper)) %>% 
  mutate(date = coalesce(as.Date(index), as.Date(slice_id)))
```

## Plotting the results

Plotting the outcome is relatively simple with `ggplot2`:

```{r, fig.width=7, fig.height=6, fig.align="center", eval=TRUE}
beta %>% 
  ggplot(aes(date, estimate)) +
  facet_wrap("term", scales = "free", ncol = 2) +
  geom_ribbon(aes(ymax = upper, ymin = lower, fill = model), alpha = 0.25) +
  geom_line(aes(color = model)) +
  theme_bw(8)
```

We can make a two interesting observations from these results:

  1. The variation seen in the rolling regression for some of the parameters --- specifically the risk-adjusted alpha (intercept) and the market beta --- is not supported by the TVP model, which shrinks these to almost constant parameters.
  2. The TVP estimates are markedly smoother and importantly remove the window effects seen in the rolling regression (i.e. the rolling regression adjusts too late).

The TVP model seems to offer a much better tool analyze the factor betas in this case. 

---
title: "Bootstrapping Confidence Intervals"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Bootstrapping Confidence Intervals}
  %\VignetteEngine{knitr::knitr}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE, eval=TRUE}
use_saved_results <- TRUE

knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  eval = !use_saved_results,
  message = FALSE,
  warning = FALSE
)

if (use_saved_results) {
  library(pls)
  results <- readRDS("vignette_bci.rds")
  estimates <- results$estimates
  jackknife_estimates <- results$jackknife_estimates
}
```

```{r, eval=TRUE}
library(dplyr); library(tidyr); library(purrr); library(ggplot2) # Data wrangling
library(tidyfit) # Model fitting
```

The combination of `.cv = "bootstraps"` and `.return_slices = TRUE` in `tidyfit::regress` or `tidyfit::classify` makes it very easy to calculate bootstrap confidence intervals for estimated coefficients. As an additional convenience function, `coef.tidyfit.models` includes the option of adding percentile bootstrap intervals directly. In this short example, I will calculate and compare bootstrap confidence bands for a partial least squares regression and a principal components regression using Boston house price data:

```{r, eval=TRUE}
data <- MASS::Boston %>% 
  scale %>% 
  as_tibble
```

`tidyfit` handles data scaling internally (i.e. PLSR and PCR are always fitted on scaled data), however, scaling the data manually here will give us standardized coefficients, which are easier to visualize and compare.

## Fit the model

Instead of selecting an optimal number of latent components, I define a preset. This keeps things a little simpler. Note that dropping the `ncomp = 5` argument results the optimal number of components being selected using bootstrap resampling.

```{r}
model_frame <- data %>% 
  regress(medv ~ ., m("plsr", ncomp = 5), m("pcr", ncomp = 5),
          .cv = "bootstraps", .cv_args = list(times = 100), 
          .return_slices = TRUE)
```

The coefficients are returned for each slice when `.add_bootstrap_intervals = FALSE` (default behavior --- see `coef(model_frame)`). To obtain bootstrap intervals, I pass `.add_bootstrap_interval = TRUE` to `coef`:

```{r}
estimates <- coef(model_frame, 
                  .add_bootstrap_interval = TRUE, 
                  .bootstrap_alpha = 0.05)
```

```{r, eval=TRUE}
estimates
```

The intervals are nested in `model_info`:

```{r, eval=TRUE}
estimates <- estimates %>% 
  unnest(model_info)
estimates
```

## Plot the results

And thus, in a concise workflow, we have 95% bootstrap confidence intervals for the coefficients of a PCR and PLS regression:

```{r, fig.width=7, fig.height=3.5, fig.align="center", eval=TRUE}
estimates %>% 
  filter(term != "(Intercept)") %>% 
  ggplot(aes(term, estimate, color = model)) +
  geom_hline(yintercept = 0) +
  geom_errorbar(aes(ymin = .lower, ymax = .upper), position = position_dodge()) +
  theme_bw(8)
```

## Comparing to built-in jackknife procedure

The `pls`-package includes built-in functionality to jackknife confidence intervals for the coefficients. We can compare these results by passing `jackknife = TRUE` and `validation = "LOO"` to `m()`, and setting `.cv = "none"` (default):

```{r}
model_frame_jackknife <- data %>% 
  regress(medv ~ ., m("plsr", ncomp = 5, jackknife = TRUE, validation = "LOO"), 
          m("pcr", ncomp = 5, jackknife = TRUE, validation = "LOO"))

jackknife_estimates <- coef(model_frame_jackknife)
```

Now the `coef()` generic method also provides standard errors and $p$-values for the coefficients using `pls::jack.test`:

```{r, eval = TRUE}
jackknife_estimates <- jackknife_estimates %>% 
  unnest(model_info) %>% 
  # Create approximate 95% intervals using 2 standard deviations
  mutate(.upper = estimate + 2 * std.error, .lower = estimate - 2 * std.error)

jackknife_estimates
```

The plot is almost exactly identical to the bootstrap results above:

```{r, fig.width=7, fig.height=3.5, fig.align="center", eval=TRUE}
jackknife_estimates %>% 
  filter(term != "(Intercept)") %>% 
  ggplot(aes(term, estimate, color = model)) +
  geom_hline(yintercept = 0) +
  geom_errorbar(aes(ymin = .lower, ymax = .upper), position = position_dodge()) +
  theme_bw(8)
```

---
title: "Accessing Fitted Model Objects"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Accessing Fitted Model Objects}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  echo = TRUE,
  message = FALSE,
  warning = FALSE
)
```

```{r}
library(dplyr); library(tidyr); library(purrr) # Data wrangling
library(tidyfit) # Auto-ML modeling
```

The fitted model object is contained in `tidyfit.models` frame in the `model_object` column as an `R6` class. The `tidyFit` `R6` class contains both the underlying model (`...$object`) as well as additional information generated during fitting and needed to obtain predictions or coefficients.

Suppose, for instance, we want to visualize the regression tree of the hierarchical features regression for different degrees of shrinkage (see `?hfr::plot.hfr`). We begin by loading Boston house price data and fitting a regression for 4 different shrinkage parameters. Note that we do not need to specify a `.cv` argument, since we are not looking to select the optimal degree of shrinkage:

```{r}
data <- MASS::Boston
mod_frame <- data %>% 
  regress(medv ~ ., m("hfr", kappa = c(0.25, 0.5, 0.75, 1))) %>% 
  unnest(settings)
mod_frame
```

`kappa` defines the extent of shrinkage, with `kappa = 1` equal to an unregularized least squares (OLS) regression, and `kappa = 0.25` representing a regression graph that is shrunken to 25% of its original size, with 25% of the effective degrees of freedom. The regression graph is visualized using the `plot` function.

Let's examine the first model in the `tidyfit.models` frame:

```{r}
mod_frame$model_object[[1]]
```

## Accessing the fitted model

We have two options to plot the regression trees. Many generics function directly on the `tidyFit` class. Therefore, we could simply plot (in this case the unregularized regression graph):

```{r, fig.width=7, fig.height=6, fig.align='center'}
mod_frame %>% 
  filter(kappa == 1) %>% 
  pull(model_object) %>% 
  .[[1]] %>% 
  plot(kappa = 1)
```

The regression graph shows which variables have a similar explanatory effect on the target (variables that are adjacent have a similar effect). The sizes of the leaf-nodes represent the absolute size of the coefficients.

Alternatively, we could access the underlying `cv.hfr` object using `...$object`:

```{r}
mod_frame <- mod_frame %>% 
  mutate(mod = map(model_object, ~.$object))
mod_frame
```

Now there is a column with `cv.hfr` objects. This is useful, when we want to perform any analysis not directly implemented in the `tidyFit` generics.

## Comparing different regression graphs

Finally, we can use `pwalk` to compare the different settings in a plot:

```{r, fig.width=7, fig.height=6, fig.align='center'}
# Store current par before editing
old_par <- par()

par(mfrow = c(2, 2))
par(family = "sans", cex = 0.7)
mod_frame %>% 
  arrange(desc(kappa)) %>% 
  select(model_object, kappa) %>% 
  pwalk(~plot(.x, kappa = .y, 
              max_leaf_size = 2, 
              show_details = FALSE))
```

```{r}
# Restore old par
par(old_par)
```

Notice how with each smaller value of `kappa` the height of the tree shrinks and the model parameters become more similar in size. This is precisely how HFR regularization works: it shrinks the parameters towards group means over groups of similar features as determined by the regression graph.
